;; Copyright 2008, 2009, 2010, 2015 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------
;; advice.el dependency

(progn
  ;; (load "advice")
  (add-to-list 'load-path "../wip")
  (require 'arc-mode)
  (load "advice")
  (require 'arc-lzh-exe)
  (unload-feature 'advice)
  (unload-feature 'arc-lzh-exe))
arc-lzh-exe-unload-hook
(fboundp 'archive-lzh-exe-summarize)

(car load-history)
(pp (assoc "arc-lzh-exe" load-history) (current-buffer))
("arc-lzh-exe" archive-lzh-exe-mode-maybe archive-exe-p
 (provide . arc-lzh-exe))


;;-----------------------------------------------------------------------------

(progn
  (add-to-list 'load-path "..")
  (autoload 'archive-lzh-exe-mode-maybe "arc-lzh-exe" nil t)
  (add-to-list 'auto-mode-alist '("\\.\\(exe\\|EXE\\)\\'"
				  . archive-lzh-exe-mode-maybe))
  (modify-coding-system-alist 'file "\\.\\(exe\\|EXE\\)\\'"
			      'raw-text-unix)
  )

(progn
  (add-to-list 'load-path "..")
  (autoload 'archive-lzh-exe-mode-maybe "arc-lzh-exe")
  (autoload 'archive-exe-p              "arc-lzh-exe")
  (if (boundp 'magic-mode-alist)
      ;; emacs 22
      (add-to-list 'magic-mode-alist '(archive-exe-p . archive-mode))
    ;; emacs 21
    (modify-coding-system-alist 'file "\\.\\(exe\\|EXE\\)\\'"
                                'raw-text-unix)
    (add-to-list 'auto-mode-alist
                 '("\\.\\(exe\\|EXE\\)\\'" . archive-lzh-exe-mode-maybe))))


auto-mode-alist
magic-mode-alist
file-coding-system-alist

(setq debug-on-error t)
(find-file "~/chart/samples/kex/YCN05.exe")
(find-file "~/chart/samples/kex/CF01.exe")
(find-file "~/chart/samples/kex/BRO07.exe")

(find-file "/usr/lib/gettext/msgfmt.net.exe")




(progn
  (require 'autoload)
  (find-file "/tmp/x.el")
  (erase-buffer)
  (generate-file-autoloads "../arc-lzh-exe.el")
  (save-buffer)
  (byte-compile-file (buffer-file-name))
  (delete-file (concat (buffer-file-name) "c"))
  (delete-file (buffer-file-name)))


(require 'arc-mode)
(require 'archive-mode)
(require '(archive-mode arc-mode))

(progn
  (add-to-list 'load-path "..")

  (find-file "~/chart/samples/kex/CF05.exe")
)

  (find-file "/tmp/x.exe")


features
  (add-to-list 'auto-mode-alist '("exe" . archive-lzh-exe-mode-maybe))

  (add-to-list 'auto-mode-alist '("exe" . text-mode))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

