;; Copyright 2014 Kevin Ryde

;; This file is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; This file is distributed in the hope that it will be useful, but WITHOUT
;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;; FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;; more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with this file; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



(defun my-guile-pk (&optional remove)
  "Put a Guile (pk ...) around the form at point.
With \\[universal-argument] prefix arg, remove (pk ...) at point."
  (interactive "P")
  (if remove
      (save-excursion
        (while (progn
                 (if (looking-at "(pk ")
                     (progn
                       (save-excursion
                         (forward-sexp)
                         (delete-region (1- (point)) (point)))
                       (delete-region (point) (+ 4 (point)))
                       nil)

                   (condition-case nil
                       (progn
                         (up-list)
                         (backward-sexp))
                     (error (error "Not in a `pk' form.")))
                   t))))

    (save-excursion
      (save-excursion
        (forward-sexp)
        (insert ")"))
      (insert "(pk "))))

;; (define-key emacs-lisp-mode-map [?\C-c ?p]    'my-guile-pk)
