;; -*- coding: utf-8 -*-

;; Copyright 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(progn
  (require 'byte-opt-concat)
  (dolist (elem '(((concat) (concat))
                  ((concat "") (concat ""))
                  ((concat "x") (concat "x"))
                  ((concat "x" "y") (concat "xy"))
                  ((concat "x" y "z") (concat "x" y "z"))
                  ((concat "x" y ?z) (concat "x" y ?z))
                  ((concat a "b" "c" "d" e) (concat a "bcd" e))

                  ((insert) (insert))
                  ((insert "\n") (insert 10))
                  ((insert "\n" "") (insert 10))
                  ((insert "x" "\n") (insert "x\n"))
                  ((insert "x\n") (insert "x\n"))
                  ((insert "•") (insert "•"))
                  ))
    (let* ((form (nth 0 elem))
           (want (nth 1 elem))
           (handler (get (car form) 'byte-optimizer))
           (got (funcall handler form)))
      (unless (equal got want)
        (error "%S want %S got %S" form want got)))))
